; by Jautois - 2010
; Version: 0.1

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include "WinHTTP.au3"
#include <GDIPlus.au3>

Global $aAverage[1]
Global $iLastID = ""
Global $iCurResult = ""
Global $iCurStatus = -1
Global $iRight = 0
Global $iWrong = 0
Global $iLastAt = ""
Global $iLastUResult = ""
Global $pInput_HighRange, $pInput_LowRange
Global $sIcon = @ScriptDir & "\form.ico"

$hWindow = GUICreate("KT - KopfrechenTrainer by Jautois v.0.1", 514, 562)
GUIRegisterMsg($WM_COMMAND, "_Range")
GUISetIcon($sIcon)
GUISetFont(8, 400, 0, "Verdana")
GUICtrlCreateGroup("Einstellungen", 8, 8, 497, 233)
GUICtrlCreateGroup("Zahlenbereich [-1000 bis +1000]", 16, 32, 329, 65)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Rechenarten", 16, 104, 329, 129)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Sonstiges", 352, 32, 145, 201)
$pButton_Res = GUICtrlCreateButton("Ergebnisse", 256, 520, 105, 33, $WS_GROUP)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateLabel("bis", 152, 64, 20, 17)
$pInput_LowRange = GUICtrlCreateInput("-10", 69, 58, 65, 21)
GUICtrlCreateUpdown(-1)
GUICtrlCreateLabel("Von", 37, 64, 26, 17)
$pInput_HighRange = GUICtrlCreateInput("10", 181, 58, 57, 21)
GUICtrlCreateUpdown(-1)
GUICtrlCreateGroup("Aufgabe", 8, 248, 497, 265)
$pInput_Result = GUICtrlCreateInput("10", 360, 277, 129, 33)
GUICtrlSetFont(-1, 16, 400, 0, "Verdana")
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetColor(-1, 0xC0C0C0)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$pCheckbox_Add = GUICtrlCreateCheckbox("Addition", 40, 128, 97, 25)
GUICtrlSetState(-1, $GUI_CHECKED)
$iLastID = $pCheckbox_Add
$pCheckbox_Sub = GUICtrlCreateCheckbox("Subtraktion", 40, 152, 97, 25)
$pCheckbox_Mult = GUICtrlCreateCheckbox("Multiplikation", 40, 176, 97, 25)
$pCheckbox_Div = GUICtrlCreateCheckbox("Division", 40, 200, 97, 25)
$pCheckbox_Sound = GUICtrlCreateCheckbox("Sound", 368, 56, 89, 17)
$pLabel_Sum = GUICtrlCreateLabel("3 + 7", 24, 280, 290, 29, $SS_CENTER)
GUICtrlSetFont(-1, 16, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0xC0C0C0)
GUICtrlCreateLabel("=", 328, 272, 30, 42)
GUICtrlSetFont(-1, 24, 400, 0, "Verdana")
$pLabel_Output = GUICtrlCreateLabel("", 24, 325, 290, 50, $SS_CENTER)
GUICtrlSetFont(-1, 16, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0x008000)
GUICtrlCreateGroup("Statistik", 16, 392, 489, 113)
$pLabel_Right = GUICtrlCreateLabel("Richtig" & @CRLF & @CRLF & $iRight, 96, 416, 60, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0x008000)
$pLabel_Wrong = GUICtrlCreateLabel("Falsch" & @CRLF & @CRLF & $iWrong, 220, 416, 55, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$pLabel_Average = GUICtrlCreateLabel("Durchschnitt" & @CRLF & @CRLF & "-", 328, 416, 106, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
$pButton_Check = GUICtrlCreateButton("berprfen", 360, 320, 129, 33, BitOR($BS_DEFPUSHBUTTON, $WS_GROUP))
GUICtrlSetState(-1, $GUI_DISABLE)
$pButton_Start = GUICtrlCreateButton("Start", 8, 520, 137, 33, $WS_GROUP)
GUICtrlSetState(-1, $GUI_FOCUS)
$pButton_Exit = GUICtrlCreateButton("Beenden", 368, 520, 137, 33, $WS_GROUP)
$pButton_Stop = GUICtrlCreateButton("Stop", 152, 520, 100, 33, $WS_GROUP)
GUICtrlSetState($pButton_Stop, $GUI_DISABLE)
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $pButton_Stop
			$iCurStatus = 0
			$iRight = 0
			$iWrong = 0
			GUICtrlSetState($pButton_Stop, $GUI_DISABLE)
			GUICtrlSetState($pButton_Start, $GUI_ENABLE)

			GUICtrlSetData($pLabel_Right, "Richtig" & @CRLF & @CRLF & $iRight)
			GUICtrlSetData($pLabel_Wrong, "Falsch" & @CRLF & @CRLF & $iWrong)
			GUICtrlSetData($pLabel_Output, "")
			GUICtrlSetData($pLabel_Average, "Durchschnitt" & @CRLF & @CRLF & "0%")
			GUICtrlSetColor($pLabel_Average, 0)
			GUICtrlSetState($pButton_Check, $GUI_DISABLE)
			GUICtrlSetData($pInput_Result, "")
			GUICtrlSetState($pInput_Result, $GUI_DISABLE)
			GUICtrlSetColor($pLabel_Sum, 0xC0C0C0)

			_Create_ArithmeticProblem()

			GUICtrlSetData($pInput_Result, $iCurResult)
			GUICtrlSetState($pButton_Start, $GUI_FOCUS)

		Case $pButton_Exit, $GUI_EVENT_CLOSE
			Exit
		Case $pButton_Res
			If $iCurStatus = 1 Then
				If Ping("www.google.de") <> 0 Then
					$sTempTx = ""

					For $i = 1 To UBound($aAverage) - 1
						$sTempTx &= $aAverage[$i] & "."
					Next

					$post = "ints=" & $sTempTx
					$hw_open = _WinHttpOpen("Client")
					$hw_connect = _WinHttpConnect($hw_open, "bbs07.spacequadrat.de")
					$h_openRequest = _WinHttpOpenRequest($hw_connect, "POST", "/Kopfrechner/src/dicst/graph.php", "HTTP/1.1", "http://www.google.de/")
					_WinHttpSendRequest($h_openRequest, "Content-Type: application/x-www-form-urlencoded" & @CRLF, $post)
					_WinHttpReceiveResponse($h_openRequest)

					If _WinHttpQueryDataAvailable($h_openRequest) Then
						$header = _WinHttpQueryHeaders($h_openRequest)
					EndIf

					Local $data = ""
					Do
						$data &= _WinHttpReadData($h_openRequest, 2)
					Until @error
					$sCurFileN = "KT-Ergebnisse_" & @MDAY & "." & @MON & "." & @YEAR & "_" & Random(1000, 9999, 1) & ".png"
					$open = FileOpen($sCurFileN, 26)
					FileWrite($open, $data)
					FileClose($open)

					_WinHttpCloseHandle($h_openRequest)
					_WinHttpCloseHandle($hw_connect)
					_WinHttpCloseHandle($hw_open)

					_GDIPlus_Startup()
					$hGraphic = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\" & $sCurFileN)
					$iWidth = _GDIPlus_ImageGetWidth($hGraphic)
					$iHeight = _GDIPlus_ImageGetHeight($hGraphic)

					$hWindow_Graph = GUICreate("Ergebnisse", $iWidth, $iHeight)
					GUISetIcon($sIcon)
					GUISetState(@SW_SHOW, $hWindow_Graph)

					$Graphics = _GDIPlus_GraphicsCreateFromHWND($hWindow_Graph)
					$Bitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $Graphics)
					$hBuffer = _GDIPlus_ImageGetGraphicsContext($Bitmap)
					_GDIPlus_GraphicsDrawImage($hBuffer, $hGraphic, 0, 0)
					_GDIPlus_GraphicsDrawImageRect($Graphics, $Bitmap, 0, 0, $iWidth, $iHeight)

					While 1
						$nMsg = GUIGetMsg()
						Switch $nMsg
							Case $GUI_EVENT_CLOSE
								FileDelete(@ScriptDir & "\" & $sCurFileN)
								For $i = 1 To UBound($aAverage) - 1
									_ArrayDelete($aAverage, $i)
								Next
								GUIDelete($hWindow_Graph)
								ExitLoop
						EndSwitch
					WEnd
				Else
					MsgBox(48, "Info", "Keine Internetverbindung")
				EndIf
			Else
				MsgBox(48, "Info", "Keine Ergebnisse vorhanden!")
			EndIf
		Case $pButton_Check
			If $iCurStatus = 1 Then
				_Check_ArithmeticProblem()
			EndIf
		Case $pButton_Start
			GUICtrlSetState($pButton_Stop, $GUI_ENABLE)
			GUICtrlSetState($pButton_Check, $GUI_ENABLE)
			GUICtrlSetState($pButton_Start, $GUI_DISABLE)
			GUICtrlSetState($pInput_Result, $GUI_ENABLE)
			GUICtrlSetColor($pLabel_Sum, 0)
			GUICtrlSetColor($pInput_Result, 0)
			GUICtrlSetData($pInput_Result, "")
			GUICtrlSetData($pLabel_Average, "Durchschnitt" & @CRLF & @CRLF & "0%")
			GUICtrlSetState($pInput_Result, $GUI_FOCUS)
			_Create_ArithmeticProblem()
		Case $pCheckbox_Add
			If $iLastID <> $pCheckbox_Add Then
				GUICtrlSetState($pCheckbox_Add, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				$iLastID = $pCheckbox_Add
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Add, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Sub
			If $iLastID <> $pCheckbox_Sub Then
				GUICtrlSetState($pCheckbox_Sub, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				$iLastID = $pCheckbox_Sub
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Sub, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Mult
			If $iLastID <> $pCheckbox_Mult Then
				GUICtrlSetState($pCheckbox_Mult, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				$iLastID = $pCheckbox_Mult
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Mult, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Div
			If $iLastID <> $pCheckbox_Div Then
				GUICtrlSetState($pCheckbox_Div, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				$iLastID = $pCheckbox_Div
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Div, $GUI_CHECKED)
			EndIf
	EndSwitch
WEnd

Func _Range($hWnd, $iMsg, $iwParam, $ilParam)
	If Not IsHWnd($pInput_HighRange) Then $hWndHR = GUICtrlGetHandle($pInput_HighRange)
	If Not IsHWnd($pInput_LowRange) Then $hWndLR = GUICtrlGetHandle($pInput_LowRange)
	Switch $ilParam
		Case $hWndHR
			If GUICtrlRead($pInput_HighRange) > 1000 Then
				GUICtrlSetData($pInput_HighRange, 1000)
			ElseIf GUICtrlRead($pInput_LowRange) = 0 And GUICtrlRead($pInput_HighRange) = 0 Then
				GUICtrlSetData($pInput_HighRange, 1)
			ElseIf GUICtrlRead($pInput_HighRange) < 0 Then
				GUICtrlSetData($pInput_HighRange, 0)
			EndIf
		Case $hWndLR
			If GUICtrlRead($pInput_LowRange) < -1000 Then
				GUICtrlSetData($pInput_LowRange, -1000)
			ElseIf GUICtrlRead($pInput_LowRange) = 0 And GUICtrlRead($pInput_HighRange) = 0 Then
				GUICtrlSetData($pInput_LowRange, 1)
			ElseIf GUICtrlRead($pInput_LowRange) > 0 Then
				GUICtrlSetData($pInput_LowRange, 0)
			EndIf
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_Range

Func _Check_ArithmeticProblem()
	If $iRight > -1 Or $iWrong > -1 Then GUICtrlSetState($pButton_Res, $GUI_ENABLE)

	$iLastUResult = GUICtrlRead($pInput_Result)
	If $iLastUResult == $iCurResult Then
		$iRight += 1
		GUICtrlSetData($pLabel_Right, "Richtig" & @CRLF & @CRLF & $iRight)
		GUICtrlSetData($pLabel_Output, "Richtig! " & $iLastAt)
		GUICtrlSetColor($pLabel_Output, 0x008000)
	Else
		$iWrong += 1
		GUICtrlSetData($pLabel_Wrong, "Falsch" & @CRLF & @CRLF & $iWrong)
		GUICtrlSetData($pLabel_Output, "Falsch! != " & $iLastUResult & @CRLF & $iLastAt)
		GUICtrlSetColor($pLabel_Output, 0xFF0000)
	EndIf

	GUICtrlSetData($pInput_Result, "")
	GUICtrlSetState($pInput_Result, $GUI_FOCUS)

	$iAverage = Round((100 / ($iRight + $iWrong)) * $iRight, 0)

	_ArrayAdd($aAverage, $iAverage)

	GUICtrlSetData($pLabel_Average, "Durchschnitt" & @CRLF & @CRLF & $iAverage & "%")
	Switch $iAverage
		Case 0 To 50
			GUICtrlSetColor($pLabel_Average, 0xFF0000)
		Case 50 To 75
			GUICtrlSetColor($pLabel_Average, 0xFF9900)
		Case 75 To 100
			GUICtrlSetColor($pLabel_Average, 0x008000)
	EndSwitch

	_Create_ArithmeticProblem()
EndFunc   ;==>_Check_ArithmeticProblem

Func _Create_ArithmeticProblem()
	Local $LowR = GUICtrlRead($pInput_LowRange)
	Local $HighR = GUICtrlRead($pInput_HighRange)

	$iFirstSum = Random($LowR, $HighR, 1)
	$iSecondSum = Random($LowR, $HighR, 1)

	$iCurStatus = 1

	Switch $iLastID
		Case 21
			;- Addition
			$iCurResult = $iFirstSum + $iSecondSum
			$iLastAt = $iFirstSum & " + " & $iSecondSum
		Case 22
			;- Subtraktion
			$iCurResult = $iFirstSum - $iSecondSum
			$iLastAt = $iFirstSum & " - " & $iSecondSum
		Case 23
			;- Multiplikation
			$iCurResult = $iFirstSum * $iSecondSum
			$iLastAt = $iFirstSum & " * " & $iSecondSum
		Case 24
			;- Division
			$iCurResult = $iFirstSum / $iSecondSum
			$iLastAt = $iFirstSum & " / " & $iSecondSum
	EndSwitch

	GUICtrlSetData($pLabel_Sum, $iLastAt)

	If $iCurStatus <> 1 Then
		GUICtrlSetData($pInput_Result, $iCurResult)
	EndIf

	$iLastAt &= " = " & $iCurResult
EndFunc   ;==>_Create_ArithmeticProblem
